//
// ======== ControllableSerialInput.java ========
//
// generated by GenModule.java
//
 
/**
 * This handles serial devices which take startup and shutdown control strings.
 *
 * @version    1.0, Fri Mar 22 15:18:47  1996
 * @author     Johannes N. Johannsen, jojo@well.com
 */
public class ControllableSerialInput extends SerialPortInput {
 
   /**
    * Streams access by user names below, or vectors declared in NeatToolsModule.
    */
   NeatInputStream start;
   NeatInputStream stop;
 
 
   /**
    * Constructor for ControllableSerialInput
    */
   public ControllableSerialInput() {
      super();
      start = new FixedStringStream( "" );
      inputStreams.addElement( start );
      stop = new FixedStringStream( "" );
      inputStreams.addElement( stop );
   }
 
 
   /**
    * Generated function startUp
    */
   public void startUp() {
      super.startUp();
      int len = start.getString().length();
      byte[] buf = new byte[ len ];
      start.getString().getBytes( 0, len, buf, 0 );
      nativeSerialPort.write( buf, len );
   }
 
 
   /**
    * Generated function shutDown
    */
   public void shutDown() {
      // sleep for a second to let the shutdown take effect
      try {
         Thread.sleep( 1000 );
      } catch( InterruptedException e ) {
      }
      
      // shutdown the serial port
      super.shutDown();
   }
}
