//
// ======== FramedInput.java ========
//
// generated by GenModule.java
//
 
/**
 * This is the abstract base class for any framed input.
 *
 * @version    1.0, Sun Mar 24 10:05:22  1996
 * @author     Johannes N. Johannsen, jojo@well.com
 */
abstract public class FramedInput extends InputDevice {
 
   /**
    * Streams access by user names below, or vectors declared in NeatToolsModule.
    */
   NeatInputStream dataFrameSize;
 
int goodFrameCount;
   /**
    * Constructor for FramedInput
    */
   protected FramedInput() {
      super();
      dataFrameSize = new FixedIntStream( 0 );
      inputStreams.addElement( dataFrameSize );
	  goodFrameCount = 0;
   }
 
   /**
    * Abstract method declarations
    */
   abstract void updateBuffer();
   abstract boolean frameDetected();
   abstract void extractFrame();
   abstract void cleanupBuffer();
 
 
   /**
    * Generated function update*
    */
   public void update() {
      updateBuffer();
      if ( frameDetected() ) {
         extractFrame();
		 goodFrameCount++;
      } else {
         cleanupBuffer();
      }
   }

   public void debugInfo() {
		super.debugInfo();
		System.out.println( "Good frame count: " + goodFrameCount );
	}
}
