//
// ======== Invert.java ========
//
// generated by GenModule.java
//
 
/**
 * This filter tells whether a value is above or below a given threshhold.
 *
 * @version    1.0, Fri Apr 19 07:34:11  1996
 * @author     Johannes N. Johannsen, jojo@well.com
 */
import java.awt.*;
public class Invert extends Filter {
 
   /**
    * Streams access by user names below, or vectors declared in NeatToolsModule.
    */
   NeatInputStream booleanStream;
   NeatOutputStream out_booleanStream;
 
   /**
    * Non-stream custom fields.
    */
   boolean lastValue = false;
   int mx;
   int my;
   int mw;
   int mh;
 
 
   /**
    * Constructor for Invert
    */
   public Invert() {
      super();
      booleanStream = new NeatInputStream( IOstream.BOOLEAN );
      inputStreams.addElement( booleanStream );
      out_booleanStream = new NeatOutputStream( IOstream.BOOLEAN );
      outputStreams.addElement( out_booleanStream );
   }
 
 
   /**
    * Generated function update*
    */
   public void update() {
      if ( booleanStream.dataAvailable ) {
         if ( booleanStream.isTrue() ) {
            out_booleanStream.setBoolean( false );
            if ( lastValue ) {
               lastValue = false;
               NeatToolsApplication.application.qrepaint(  );
            }
         } else {
            out_booleanStream.setBoolean( true );
            if ( !lastValue ) {
               lastValue = true;
               NeatToolsApplication.application.qrepaint(  );
            }
         }
      }
      
   }
 
 
   /**
    * Generated function setModuleBoundaries
    */
   public void setModuleBoundaries( int x, int y, int width, int height ) {
      mx = x;
      my = y;
      mw = width;
      mh = height;
   }
 
 
   /**
    * Generated function display
    */
   public void display( Graphics g ) {
      if ( lastValue ) {
         g.setColor( Color.green );
      } else {
         g.setColor( Color.red );
      }
      g.fillRect( mx, my, mw, mh );
   }
 
 
   /**
    * Generated function startUp*
    */
   public void startUp() {
      NeatToolsApplication.application.qrepaint( this );
   }
}
