//
// ======== ParallelPortOutput.java ========
//
// generated by GenModule.java
//

/**
 * handles parallel port output
 *
 * @version    1.0, Wed Apr 24 05:52:09  1996
 * @author     Johannes N. Johannsen, jojo@well.com
 */
public class ParallelPortOutput extends OutputDevice {
 
   /**
    * Streams access by user names below, or vectors declared in NeatToolsModule.
    */
   NeatInputStream portNumber;
   NeatInputStream intStream;
 
   /**
    * Non-stream custom fields.
    */
   NativeParallelPort nativeParallelPort;
 
 
   /**
    * Constructor for ParallelPortOutput
    */
   public ParallelPortOutput() {
      super();
      portNumber = new FixedIntStream( 0 );
      inputStreams.addElement( portNumber );
      intStream = new NeatInputStream( IOstream.INT );
      inputStreams.addElement( intStream );
 
      // non-stream constructor initializations...
      nativeParallelPort = new NativeParallelPort();
   }
 
 
   /**
    * Generated function update*
    */
   public void update() {
      if ( intStream.dataAvailable ) {
         nativeParallelPort.write( intStream.getInt() );
      }
   }
 
 
   /**
    * Generated function startUp*
    */
   public void startUp() {
      nativeParallelPort.setup( portNumber.getInt() );
   }
}
