//
// ======== SerialPortInput.java ========
//
// generated by GenModule.java
//
 
/**
 * This class provides serial port access.
 *
 * @version    1.0, Sat Mar 23 09:03:37  1996
 * @author     Johannes N. Johannsen, jojo@well.com
 */
public class SerialPortInput extends InputDevice {
 
   /**
    * Streams access by user names below, or vectors declared in NeatToolsModule.
    */
   NeatInputStream port;
   NeatInputStream baud;
   NeatInputStream parity;
   NeatInputStream bits;
   NeatInputStream stopBits;
   NeatInputStream byteStream;
   NeatOutputStream out_byteStream;
 
   /**
    * Non-stream custom fields.
    */
   NativeSerialPort nativeSerialPort;
   CircularBuffer buffer;
   byte[] localBuffer;
 
 
   /**
    * Constructor for SerialPortInput
    */
   public SerialPortInput() {
      super();
      port = new FixedIntStream( 0 );
      inputStreams.addElement( port );
      baud = new FixedIntStream( 0 );
      inputStreams.addElement( baud );
      parity = new FixedStringStream( "" );
      inputStreams.addElement( parity );
      bits = new FixedIntStream( 0 );
      inputStreams.addElement( bits );
      stopBits = new FixedIntStream( 0 );
      inputStreams.addElement( stopBits );
      byteStream = new NeatInputStream( IOstream.BYTE );
      inputStreams.addElement( byteStream );
      out_byteStream = new NeatOutputStream( IOstream.BYTE );
      outputStreams.addElement( out_byteStream );
 
      // non-stream constructor initializations...
      nativeSerialPort = new NativeSerialPort();
      buffer = new CircularBuffer( 1000 );
      localBuffer = new byte[100];
   }
 
 
   /**
    * Generated function startUp
    */
   public void startUp() {
      if ( !running ) {
         nativeSerialPort.configure( port.getInt(), baud.getInt(), parity.getString(), bits.getInt(), stopBits.getInt() );
         if ( nativeSerialPort.startUp() ) {
            running = true;
         }
      }
   }
 
 
   /**
    * Generated function shutDown
    */
   public void shutDown() {
      if ( running ) {
         nativeSerialPort.shutDown();
         running = false;
      }
   }
 
 
   /**
    * Generated function reset
    */
   public void reset() {
      shutDown();
      startUp();
   }
 
 
   /**
    * Generated function update
    */
   public void update() {
      if ( buffer.freeBytes() > 100 ) {
         int bytesRead = nativeSerialPort.read( localBuffer, 100 );
         buffer.putBytes( localBuffer, bytesRead );
      }
      if ( !out_byteStream.dataAvailable && buffer.hasBytes() ) {
         out_byteStream.setByte( buffer.getByte() );
      }
   }
}
