//
// ======== TNG1.java ========
//
// generated by GenModule.java
//
 
/**
 * This handles the TNG1 device made by Salomo.
 *
 * @version    1.0, Sat Mar 23 08:20:26  1996
 * @author     Johannes N. Johannsen, jojo@well.com
 */
public class TNG1 extends ByteFramedInput {
 
   /**
    * Streams access by user names below, or vectors declared in NeatToolsModule.
    */
   NeatInputStream baud;
   NeatInputStream parity;
   NeatInputStream bits;
   NeatInputStream stopBits;
   NeatOutputStream out_channel[];
 
 
   /**
    * Constructor for TNG1
    */
   public TNG1() {
      super();
      dataFrameSize.setInt( 4 );
      frameMarker.setByte( (byte)255 );
      baud = new FixedIntStream( 9600 );
      inputStreams.addElement( baud );
      parity = new FixedStringStream( "N" );
      inputStreams.addElement( parity );
      bits = new FixedIntStream( 8 );
      inputStreams.addElement( bits );
      stopBits = new FixedIntStream( 1 );
      inputStreams.addElement( stopBits );
      out_channel = new NeatOutputStream[4];
      out_channel[0] = new NeatOutputStream( IOstream.BYTE );
      outputStreams.addElement( out_channel[0] );
      out_channel[1] = new NeatOutputStream( IOstream.BYTE );
      outputStreams.addElement( out_channel[1] );
      out_channel[2] = new NeatOutputStream( IOstream.BYTE );
      outputStreams.addElement( out_channel[2] );
      out_channel[3] = new NeatOutputStream( IOstream.BYTE );
      outputStreams.addElement( out_channel[3] );
   }
 
 
   /**
    * Generated function startUp*
    */
   public void startUp() {
      // does nothing
   }
 
 
   /**
    * Generated function shutDown*
    */
   public void shutDown() {
      // does nothing
   }
 
 
   /**
    * Generated function reset*
    */
   public void reset() {
      // does nothing
   }
 
 
   /**
    * Generated function extractFrame*
    */
   public void extractFrame() {
      buffer.setStart( 0 );  // start of frame
      buffer.getByte();  // skip over frame marker
      for ( int  i = 0; i < 4; i++ ) {
         out_channel[i].setByte( buffer.getByte() );
      }
   }
}
