//
// ======== TNG2.java ========
//
// generated by GenModule.java
//
 
/**
 * This handles the TNG2 device made by Salomo
 *
 * @version    1.0, Sat Mar 23 08:49:08  1996
 * @author     Johannes N. Johannsen, jojo@well.com
 */
public class TNG2 extends ByteFramedInput {
 
   /**
    * Streams access by user names below, or vectors declared in NeatToolsModule.
    */
   NeatInputStream baud;
   NeatInputStream parity;
   NeatInputStream bits;
   NeatInputStream stopBits;
   NeatInputStream start;
   NeatInputStream stop;
   NeatOutputStream out_channel[];
 
 
   /**
    * Constructor for TNG2
    */
   public TNG2() {
      super();
      dataFrameSize.setInt( 8 );
      frameMarker.setByte( (byte)255 );
      baud = new FixedIntStream( 9600 );
      inputStreams.addElement( baud );
      parity = new FixedStringStream( "N" );
      inputStreams.addElement( parity );
      bits = new FixedIntStream( 8 );
      inputStreams.addElement( bits );
      stopBits = new FixedIntStream( 1 );
      inputStreams.addElement( stopBits );
      start = new FixedStringStream( "START" );
      inputStreams.addElement( start );
	  stop = new FixedStringStream( "(none)" );
	  inputStreams.addElement( stop );
      out_channel = new NeatOutputStream[8];
      out_channel[0] = new NeatOutputStream( IOstream.BYTE );
      outputStreams.addElement( out_channel[0] );
      out_channel[1] = new NeatOutputStream( IOstream.BYTE );
      outputStreams.addElement( out_channel[1] );
      out_channel[2] = new NeatOutputStream( IOstream.BYTE );
      outputStreams.addElement( out_channel[2] );
      out_channel[3] = new NeatOutputStream( IOstream.BYTE );
      outputStreams.addElement( out_channel[3] );
      out_channel[4] = new NeatOutputStream( IOstream.BYTE );
      outputStreams.addElement( out_channel[4] );
      out_channel[5] = new NeatOutputStream( IOstream.BYTE );
      outputStreams.addElement( out_channel[5] );
      out_channel[6] = new NeatOutputStream( IOstream.BYTE );
      outputStreams.addElement( out_channel[6] );
      out_channel[7] = new NeatOutputStream( IOstream.BYTE );
      outputStreams.addElement( out_channel[7] );
   }
 
 
   /**
    * Generated function startUp*
    */
   public void startUp() {
      // does nothing
   }
 
 
   /**
    * Generated function shutDown*
    */
   public void shutDown() {
      // does nothing
   }
 
 
   /**
    * Generated function reset*
    */
   public void reset() {
      // does nothing
   }
 
 
   /**
    * Generated function extractFrame*
    */
   public void extractFrame() {
      buffer.setStart( 0 );  // start of frame
      buffer.getByte();  // skip over frame marker
      for ( int  i = 0; i < 8; i++ ) {
         out_channel[i].setByte( buffer.getByte() );
      }
   }
}
