//
// ======== Threshold.java ========
//
// generated by GenModule.java
//
 
/**
 * This filter tells whether a value is above or below a given threshhold.
 *
 * @version    1.0, Fri Apr 19 07:39:54  1996
 * @author     Johannes N. Johannsen, jojo@well.com
 */
import java.awt.*;
public class Threshold extends Filter {
 
   /**
    * Streams access by user names below, or vectors declared in NeatToolsModule.
    */
   NeatInputStream intStream;
   NeatInputStream threshhold;
   NeatOutputStream out_above;
 
   /**
    * Non-stream custom fields.
    */
   boolean lastValue = false;
   int mx;
   int my;
   int mw;
   int mh;
 
 
   /**
    * Constructor for Threshold
    */
   public Threshold() {
      super();
      intStream = new NeatInputStream( IOstream.INT );
      inputStreams.addElement( intStream );
      threshhold = new FixedIntStream( 0 );
      inputStreams.addElement( threshhold );
      out_above = new NeatOutputStream( IOstream.BOOLEAN );
      outputStreams.addElement( out_above );
   }
 
 
   /**
    * Generated function update*
    */
   public void update() {
      if ( intStream.dataAvailable ) {
         if ( intStream.getInt() > threshhold.getInt() ) {
            out_above.setBoolean( true );
            if ( !lastValue ) {
               lastValue = true;
               NeatToolsApplication.application.qrepaint( );
            }
         } else {
            out_above.setBoolean( false );
            if ( lastValue ) {
               lastValue = false;
               NeatToolsApplication.application.qrepaint();
            }
         }
      }
   }
 
 
   /**
    * Generated function setModuleBoundaries
    */
   public void setModuleBoundaries( int x, int y, int width, int height ) {
      mx = x;
      my = y;
      mw = width;
      mh = height;
   }
 
 
   /**
    * Generated function display
    */
   public void display( Graphics g ) {
      if ( lastValue ) {
         g.setColor( Color.green );
      } else {
         g.setColor( Color.red );
      }
      g.fillRect( mx, my, mw, mh );
   }
 
 
   /**
    * Generated function startUp*
    */
   public void startUp() {
      NeatToolsApplication.application.qrepaint( this );
   }
}
